/* Automatically generated nanopb header */
/* Generated by nanopb-0.4.1 */

#ifndef PB_PROTOCOLS_PB_H_INCLUDED
#define PB_PROTOCOLS_PB_H_INCLUDED
#include <pb.h>

#if PB_PROTO_HEADER_VERSION != 40
#error Regenerate this file with the current version of nanopb generator.
#endif

#ifdef __cplusplus
extern "C" {
#endif

/* Enum definitions */
typedef enum _FollowingData {
    FollowingData_NOTHING = 0,
    FollowingData_POSITION = 1,
    FollowingData_MEASUREMENT = 2
} FollowingData;

typedef enum _Commands {
    Commands_UNKNOWN = 0,
    Commands_STATUS = 1,
    Commands_MOVETO = 2,
    Commands_MEASURE = 3,
    Commands_GET_REL_POS = 4,
    Commands_GET_ABS_POS = 5,
    Commands_SET_ZERO_POS = 6,
    Commands_HOME = 7
} Commands;

typedef enum _Errors {
    Errors_NO_ERROR = 0,
    Errors_STEPPER_ERROR = 1,
    Errors_PLANNER_ERROR = 2,
    Errors_SENSOR_ERROR = 3,
    Errors_MISC_ERROR = 4
} Errors;

/* Struct definitions */
typedef struct _Measurement_msg {
    float x;
    float y;
    float z;
} Measurement_msg;

typedef struct _Position_msg {
    float x;
    float y;
    float z;
} Position_msg;

typedef struct _Command_msg {
    uint32_t command;
    bool has_position;
    Position_msg position;
} Command_msg;

typedef struct _Return_msg {
    Commands cmdAck;
    Errors error;
    uint32_t errorCode;
    bool has_position;
    Position_msg position;
    bool has_measurement;
    Measurement_msg measurement;
} Return_msg;


/* Helper constants for enums */
#define _FollowingData_MIN FollowingData_NOTHING
#define _FollowingData_MAX FollowingData_MEASUREMENT
#define _FollowingData_ARRAYSIZE ((FollowingData)(FollowingData_MEASUREMENT+1))

#define _Commands_MIN Commands_UNKNOWN
#define _Commands_MAX Commands_HOME
#define _Commands_ARRAYSIZE ((Commands)(Commands_HOME+1))

#define _Errors_MIN Errors_NO_ERROR
#define _Errors_MAX Errors_MISC_ERROR
#define _Errors_ARRAYSIZE ((Errors)(Errors_MISC_ERROR+1))


/* Initializer values for message structs */
#define Return_msg_init_default                  {_Commands_MIN, _Errors_MIN, 0, false, Position_msg_init_default, false, Measurement_msg_init_default}
#define Command_msg_init_default                 {0, false, Position_msg_init_default}
#define Position_msg_init_default                {0, 0, 0}
#define Measurement_msg_init_default             {0, 0, 0}
#define Return_msg_init_zero                     {_Commands_MIN, _Errors_MIN, 0, false, Position_msg_init_zero, false, Measurement_msg_init_zero}
#define Command_msg_init_zero                    {0, false, Position_msg_init_zero}
#define Position_msg_init_zero                   {0, 0, 0}
#define Measurement_msg_init_zero                {0, 0, 0}

/* Field tags (for use in manual encoding/decoding) */
#define Measurement_msg_x_tag                    1
#define Measurement_msg_y_tag                    2
#define Measurement_msg_z_tag                    3
#define Position_msg_x_tag                       1
#define Position_msg_y_tag                       2
#define Position_msg_z_tag                       3
#define Command_msg_command_tag                  1
#define Command_msg_position_tag                 2
#define Return_msg_cmdAck_tag                    1
#define Return_msg_error_tag                     2
#define Return_msg_errorCode_tag                 3
#define Return_msg_position_tag                  4
#define Return_msg_measurement_tag               5

/* Struct field encoding specification for nanopb */
#define Return_msg_FIELDLIST(X, a) \
X(a, STATIC,   REQUIRED, UENUM,    cmdAck,            1) \
X(a, STATIC,   REQUIRED, UENUM,    error,             2) \
X(a, STATIC,   REQUIRED, UINT32,   errorCode,         3) \
X(a, STATIC,   OPTIONAL, MESSAGE,  position,          4) \
X(a, STATIC,   OPTIONAL, MESSAGE,  measurement,       5)
#define Return_msg_CALLBACK NULL
#define Return_msg_DEFAULT NULL
#define Return_msg_position_MSGTYPE Position_msg
#define Return_msg_measurement_MSGTYPE Measurement_msg

#define Command_msg_FIELDLIST(X, a) \
X(a, STATIC,   REQUIRED, UINT32,   command,           1) \
X(a, STATIC,   OPTIONAL, MESSAGE,  position,          2)
#define Command_msg_CALLBACK NULL
#define Command_msg_DEFAULT NULL
#define Command_msg_position_MSGTYPE Position_msg

#define Position_msg_FIELDLIST(X, a) \
X(a, STATIC,   REQUIRED, FLOAT,    x,                 1) \
X(a, STATIC,   REQUIRED, FLOAT,    y,                 2) \
X(a, STATIC,   REQUIRED, FLOAT,    z,                 3)
#define Position_msg_CALLBACK NULL
#define Position_msg_DEFAULT NULL

#define Measurement_msg_FIELDLIST(X, a) \
X(a, STATIC,   REQUIRED, FLOAT,    x,                 1) \
X(a, STATIC,   REQUIRED, FLOAT,    y,                 2) \
X(a, STATIC,   REQUIRED, FLOAT,    z,                 3)
#define Measurement_msg_CALLBACK NULL
#define Measurement_msg_DEFAULT NULL

extern const pb_msgdesc_t Return_msg_msg;
extern const pb_msgdesc_t Command_msg_msg;
extern const pb_msgdesc_t Position_msg_msg;
extern const pb_msgdesc_t Measurement_msg_msg;

/* Defines for backwards compatibility with code written before nanopb-0.4.0 */
#define Return_msg_fields &Return_msg_msg
#define Command_msg_fields &Command_msg_msg
#define Position_msg_fields &Position_msg_msg
#define Measurement_msg_fields &Measurement_msg_msg

/* Maximum encoded size of messages (where known) */
#define Return_msg_size                          44
#define Command_msg_size                         23
#define Position_msg_size                        15
#define Measurement_msg_size                     15

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif
